//   1MHz Frequency Counter             *
// This code was written for the free c compiler that comes with MPLAB.
// Time base is 1 second, generated by TMR2 from the 4MHz crystal osc.
// TMR1 is used for the counter, the overflows are counted in reg freq.
// Every second the UART transmits the 20 bits binary
// frequency count in 3 bytes.  
//
// This code is free to use, for more info   http://www.moty22.co.uk 
   
#include <htc.h>
//prototypes
void send(unsigned char bytex);
void init(void);
void main(void);

__CONFIG(MCLRDIS & WDTDIS & UNPROTECT & XT);

int freq, msec;

void init(void){

	CMCON = 0b00000111;		//comparator off
	T2CON = 0b111001;		//TMR2 prescale=4, postscale=1:8, TMR OFF
	T1CON = 0b110;        //TMR1 prescale 1:1, osc=off
	RCSTA = 0b10010000;		//rx enable 
	PR2 = 249;				//TMR2 period 4ms
	TXSTA = 0b00100000;		//tx status 
	SPBRG = 51;				//baud rate 1200bps
	TRISB = 0b11100010;		 //RB 1,5,6,7 inputs
}

void main(){
	init();
for(;;){	
	freq = 0;
	msec = 0;
	TMR2 = 0;
	TMR1L = 0;
	TMR1H = 0;
	TMR1IF = 0;
	TMR2IF = 0;
	TMR1ON = 1;		// open gate
	TMR2ON = 1;		// start count
	
	while (msec < 125 ){		//loop for 1 second
		if (TMR1IF){
			TMR1IF = 0;
			freq++;
			}
		if (TMR2IF){
			TMR2IF = 0;
			msec++;
			}
	}
	
	TMR1ON = 0;		//close gate 
	TMR2ON = 0;		//stop count
	send(TMR1L);	//transmit bytes
	send(TMR1H);
	send(freq);
	}
}

void send(unsigned char bytex){
	TXREG = bytex;
	while (!TXIF){		//wait for UART to finish
		}
}						
	
